package example.energy.coolemall;

import schedframe.Parameter;
import schedframe.resources.computing.ComputingResource;
import schedframe.resources.computing.profiles.energy.EnergyEvent;
import schedframe.resources.computing.recs.Node;
import schedframe.resources.computing.recs.NodeGroup;
import schedframe.scheduling.manager.tasks.JobRegistry;
import example.energy.BaseEnergyEstimationPlugin;

public class NodeGroupEnergyEstimationPlugin extends BaseEnergyEstimationPlugin{

	public double estimatePowerConsumption(EnergyEvent event, JobRegistry jobRegistry,
			ComputingResource resource) {
		double powerConsumption = 0;
		NodeGroup nodeGroup = (NodeGroup)resource;
		for(Node cn: nodeGroup.getNodes()){
			try{
				powerConsumption = powerConsumption + cn.getPowerInterface().getRecentPowerUsage().getValue();
			} catch (Exception e){
				
			}
		}
		try {
			powerConsumption = powerConsumption + nodeGroup.getPowerInterface().getPowerConsumption(nodeGroup.getPowerInterface().getPowerState());
		} catch (NoSuchFieldException e) {
			Parameter param = nodeGroup.getResourceCharacteristic().getParameters().get("maxPower");
			if(param != null)
				powerConsumption = powerConsumption + Double.valueOf(param.get(0).getContent());
		}

		return powerConsumption;
	}

}
